<?php
     
    if( !defined('SOCIAL_DIR') ) die(); // cannot be loaded directly

    class SocialEx{
        
        var $node;
        var $handle;
        
        function SocialEx( $params, $node ){
            global $FUNCS;
            
            $this->node = $node;
            
            extract( $FUNCS->get_named_vars(
                    array( 
                           'handle'=>'',
                    ),
                $params)
            );
            
            // sanitize params
            $handle = strtolower( trim($handle) );
            if( !in_array($handle, array('facebook', 'twitter', 'instagram', 'google+')) ){
              die( "ERROR: Tag \"".$node->name."\": unsupported social network specified" );
            }
            $this->handle = $handle;
        }

        function fetch_social(){
            global $FUNCS;

            require( SOCIAL_DIR . "config.php");

            $account = $this->handle;
            
            $cache_file = K_COUCH_DIR . 'cache/'.$account.'_'.$FUNCS->hash_hmac( $url, $FUNCS->hash_hmac($url, $FUNCS->_get_nonce_secret_key()) ).'.txt';
            $cache_file_created = 0;
            
            if( (file_exists($cache_file)) && ($fp = @fopen($cache_file, 'rb')) ){
                flock( $fp, LOCK_SH );
                $cached_json = @fread( $fp, filesize($cache_file) );
                flock( $fp, LOCK_UN );
                fclose( $fp );
                
                $cache_file_created = filemtime( $cache_file );
                $cached_social = json_decode( $cached_json ); 
            }
            
            if( is_array($cached_social) && (time()-$cachetime < $cache_file_created) ){ // check if the cache has not expired
                $data = $cached_social;
            }else{

	            switch ($account){
	                case 'facebook': 
	                    $url = 'http://graph.facebook.com/'.$facebook; 
	                    $url = file_get_contents($url);
	                    break;
	                case 'twitter': 
	                	$url = 'https://api.twitter.com/1.1/users/show.json?screen_name='.$twitter;
	                	
						require_once( SOCIAL_DIR.'twitteroauth/twitteroauth.php' );
		                $oauth = new TwitterOAuth( $consumerkey, $consumersecret, $accesstoken, $accesstokensecret );
		                if( $oauth ){
		                    $oauth->decode_json = false;
							$url = $oauth->get( $url );
		                }
	                    break;
	                case 'instagram': 
	                    $url = 'https://api.instagram.com/v1/users/'.$instagram_id.'/?access_token='.$instagram_accesstoken; 
	                    $url = file_get_contents($url);
	                    break;
	                case 'google+': 
	                    $url = 'https://www.googleapis.com/plus/v1/people/'.$googleplus_id.'?key='.$googleplus_key; 
	                    $url = file_get_contents($url);
	                    break;
	            }
            
				// cache fetched social
                if( $fp = @fopen($cache_file, 'wb') ){
                    flock( $fp, LOCK_EX );
                    fwrite( $fp, $url );
                    flock( $fp, LOCK_UN );
                    fclose( $fp );
                    @chmod( $cache_file, 0777 );
                }
	
            	$data = json_decode($url, true);
            }

            $html = $this->process_social( $data );
            
            return $html;

        }

        function process_social( $data ){
            global $FUNCS, $CTX;

            $account = $this->handle;

            //facebook
            if ($account == 'facebook'){
                $CTX->set( 'id', $data['id'], 'global' );
                $CTX->set( 'about', $data['about'], 'global' );
                $CTX->set( 'category', $data['category'], 'global' );
                $CTX->set( 'checkins', $data['checkins'], 'global' );
                $CTX->set( 'cover_id', $data['cover_id'], 'global' );
                $CTX->set( 'cover_image', $data['source'], 'global' );
                $CTX->set( 'name', $data['name'], 'global' );
                $CTX->set( 'username', $data['username'], 'global' );
                $CTX->set( 'website', $data['website'], 'global' );    
                $CTX->set( 'likes', $data['likes'], 'global' );
                $CTX->set( 'link', $data['link'], 'global' );
            }
            //twitter
            if ($account == 'twitter'){
                $CTX->set( 'id', $data['id'], 'global' );
                $CTX->set( 'name', $data['name'], 'global' );
                $CTX->set( 'screen_name', $data['screen_name'], 'global' );
                $CTX->set( 'description', $data['description'], 'global' );
                $CTX->set( 'link', "https://twitter.com/".$data['screen_name'], 'global' );
                $CTX->set( 'friends', $data['friends_count'], 'global' );
                $CTX->set( 'followers', $data['followers_count'], 'global' );
                $CTX->set( 'favourites', $data['favourites_count'], 'global' );
                $CTX->set( 'statuses', $data['statuses_count'], 'global' );
                $CTX->set( 'profile_image_url', $data['profile_image_url'], 'global' );

            }
            //google+
            if ($account == 'google+'){
                $CTX->set( 'followers', $data['plusOneCount'], 'global' );
				$CTX->set( 'circledByCount', $data['circledByCount'], 'global' );
				$CTX->set( 'about', $data['aboutMe'], 'global' );
				$CTX->set( 'cover_image', $data['image']['url'], 'global' );
                $CTX->set( 'link', $data['url'], 'global' );
            }
            //instagram
            if ($account == 'instagram') {
            	$data = $data['data'];
                
                $CTX->set( 'username', $data['username'], 'global' );
                $CTX->set( 'bio', $data['bio'], 'global' );
                $CTX->set( 'profile_picture', $data['profile_picture'], 'global' );
				$CTX->set( 'id', $data['id'], 'global' );
                $CTX->set( 'link', "http://instagram.com/".$data['full_name'], 'global' );
                $data = $data['counts'];
                $CTX->set( 'followers', $data['followed_by'], 'global' );
                $CTX->set( 'media', $data['media'], 'global' );
                $CTX->set( 'follows', $data['follows'], 'global' );
            }

            foreach( $this->node->children as $child ){
                $html .= $child->get_HTML();
            }

            return $html;
        }
    }
